If the device is already suspended, just return the error and skip the
code that would incorrectly wipe md->suspended_bdev.

This isn't currently a problem, though, because existing code avoids
calling this function if the device is already suspended.

Index: linux-2.6.18-rc7/drivers/md/dm.c
===================================================================
--- linux-2.6.18-rc7.orig/drivers/md/dm.c	2006-10-13 17:42:38.000000000 +0100
+++ linux-2.6.18-rc7/drivers/md/dm.c	2006-10-13 17:43:00.000000000 +0100
@@ -1285,7 +1285,7 @@ int dm_suspend(struct mapped_device *md,
 	down(&md->suspend_lock);
 
 	if (dm_suspended(md))
-		goto out;
+		goto out_unlock;
 
 	map = dm_get_table(md);
 
@@ -1361,6 +1361,8 @@ out:
 	}
 
 	dm_table_put(map);
+
+out_unlock:
 	up(&md->suspend_lock);
 	return r;
 }
